---
title: 'PaymentRequest: paymentmethodchange event'
slug: Web/API/PaymentRequest/paymentmethodchange_event
tags:
  - Event
  - Payment Request
  - Payment Request API
  - PaymentMethodChangeEvent
  - events
  - payment
  - paymentmethodchange
---
<div>{{APIRef}}</div>

<p><span class="seoSummary"><code><strong>paymentmethodchange</strong></code> events are delivered by the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> to a {{domxref("PaymentRequest")}} object when the user changes payment methods within a given payment handler.</span> For example, if the user switches from one credit card to another on their <a href="https://www.apple.com/apple-pay/">Apple Pay</a> account, a <code>paymentmethodchange</code> event is fired to let you know about the change.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("PaymentMethodChangeEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("PaymentRequest.onpaymentmethodchange", "onpaymentmethodchange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>Let's take a look at an example. This code creates a new {{domxref("PaymentRequest")}}, adds a handler for the <code>paymentmethodchange</code> event by calling the request's {{domxref("EventTarget.addEventListener", "addEventListener()")}}, then calls {{domxref("PaymentRequest.show", "show()")}} to present the payment interface to the user.</p>

<p>The code assumes the existence of a method <code>detailsForShipping()</code>, which returns a {{domxref("PaymentDetailsUpdate")}} object containing the shipping options for the <code>ground</code> shipping method, in the form found in the {{domxref("PaymentShippingOption")}} dictionary. By doing so, the payment form defaults to the ground shipping method.</p>

<pre class="brush: js">const options = {
  requestShipping: true
};

const paymentRequest = new PaymentRequest(paymentMethods,
      detailsForShipping("ground"), options);

paymentRequest.addEventListener("paymentmethodchange", handlePaymentChange, false);

paymentRequest.show()
.then(response =&gt; response.complete("success"))
.catch(err =&gt; console.log("Error handling payment request: " + err));
</pre>

<p>The event handler function itself, <code>handlePaymentChange()</code>, looks like this:</p>

<pre class="brush: js">handlePaymentChange = event =&gt; {
  const detailsUpdate = {};

  if (event.methodName === "https://apple.com/apple-pay") {
    const serviceFeeInfo = calculateServiceFee(event.methodDetails);
    Object.assign(detailsUpdate, serviceFeeInfo);
  }

  event.updateWith(detailsUpdate);
}, false);
</pre>

<p>This begins by looking at the event's {{domxref("PaymentMethodChangeEvent.methodName", "methodName")}} property; if that indicates that the user is trying to use Apple Pay, we pass the {{domxref("PaymentMethodChangeEvent.methodDetails", "methodDetails")}} into a function called <code>calculateServiceFee()</code>, which we might create to take the information about the transaction, such as the underlying credit card being used to service the Apple Pay request, and compute and return an {{domxref("PaymentDetailsUpdate")}} object that specifies changes to be applied to the {{domxref("PaymentRequest")}} in order to add any service fees that the payment method might require.</p>

<p>Before the event handler returns, it calls the event's {{domxref("PaymentRequestUpdateEvent.updateWith", "PaymentMethodChangeEvent.updateWith", "updateWith()")}} method to integrate the changes into the request.</p>

<h2 id="Related_events">Related events</h2>

<ul>
 <li>{{event("merchantvalidation")}}, {{event("shippingaddresschange")}}, {{event("shippingoptionchange")}}, and {{event("payerdetailchange")}}</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment', '#dfn-paymentmethodchange', 'paymentmethodchange')}}</td>
   <td>{{Spec2("Payment")}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.PaymentRequest.paymentmethodchange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a></li>
 <li><a href="/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API">Using the Payment Request API</a></li>
 <li>{{domxref("PaymentRequest.onpaymentmethodchange", "onpaymentmethodchange")}} event handler property</li>
 <li>Related events: {{event("merchantvalidation")}}, {{event("payerdetailchange")}}, {{event("shippingaddresschange")}}, {{event("shippingoptionchange")}}</li>
</ul>
